#include "LH155.h"


void glcd_port_init(void)
{
	glcd_ctrl_port=0x00;
	glcd_ctrl_ddr =0xff;
	
	glcd_data_port=0x00;
	glcd_data_ddr =0xff;
	
	// 
	glcd_ctrl_port|=_BV(glcd_cs);
	glcd_ctrl_port&=~_BV(glcd_rs);
	glcd_ctrl_port|=_BV(glcd_wr);
	glcd_ctrl_port|=_BV(glcd_rd);
	return;
}

void glcd_reset (void)
{
	glcd_ctrl_port&=~_BV(glcd_res);
	pause(10);
	glcd_ctrl_port|=_BV(glcd_res);
	pause(100);
}



void glcd_write_byte_inreg(unsigned char byte)
{
	/*
	// 
	glcd_ctrl_port|=_BV(glcd_cs);
	glcd_ctrl_port&=~_BV(glcd_rs);
	glcd_ctrl_port|=_BV(glcd_wr);
	*/
	
	glcd_ctrl_port&=~_BV(glcd_cs);
	
	glcd_ctrl_port|=_BV(glcd_rs);
	
	glcd_data_port=byte;
	
	//glcd_ctrl_port|=_BV(glcd_wr);
	glcd_ctrl_port&=~_BV(glcd_wr);
	pause(2);
	glcd_ctrl_port|=_BV(glcd_wr);
	
	///*
	// 
	glcd_ctrl_port|=_BV(glcd_cs);
	glcd_ctrl_port&=~_BV(glcd_rs);
	glcd_ctrl_port|=_BV(glcd_wr);
	glcd_ctrl_port|=_BV(glcd_rd);
	//*/
	return;
}


void glcd_write_byte_inram(unsigned char byte)
{
	/*
	// 
	glcd_ctrl_port|=_BV(glcd_cs);
	glcd_ctrl_port&=~_BV(glcd_rs);
	glcd_ctrl_port|=_BV(glcd_wr);
	*/
	
	glcd_ctrl_port&=~_BV(glcd_cs);
	
	glcd_ctrl_port&=~_BV(glcd_rs);
	
	glcd_data_port=byte;
	
	//glcd_ctrl_port|=_BV(glcd_wr);
	glcd_ctrl_port&=~_BV(glcd_wr);
	pause(2);
	glcd_ctrl_port|=_BV(glcd_wr);
	
	///*
	// 
	glcd_ctrl_port|=_BV(glcd_cs);
	glcd_ctrl_port&=~_BV(glcd_rs);
	glcd_ctrl_port|=_BV(glcd_wr);
	glcd_ctrl_port|=_BV(glcd_rd);
	//*/
	return;
}



unsigned char glcd_read_byte_inram(void)
{
	unsigned char byte;
	glcd_data_ddr=0x00;
	
	glcd_ctrl_port&=~_BV(glcd_cs);
	
	glcd_ctrl_port&=~_BV(glcd_rs);
	
	glcd_ctrl_port|=_BV(glcd_wr);
	
	glcd_ctrl_port|=_BV(glcd_rd);
	//pause(1);
	glcd_ctrl_port&=~_BV(glcd_rd);
	pause(1);
	
	glcd_ctrl_port|=_BV(glcd_rd);
	
	byte=glcd_data_pin;
	
	glcd_data_ddr=0xff;
	
	///*
	// 
	glcd_ctrl_port|=_BV(glcd_cs);
	glcd_ctrl_port&=~_BV(glcd_rs);
	glcd_ctrl_port|=_BV(glcd_wr);
	glcd_ctrl_port|=_BV(glcd_rd);
	//*/

	return(byte);

}

void glcd_init (void)
{
	//glcd_ctrl_port|=_BV(glcd_cs);
	//glcd_ctrl_port&=~_BV(glcd_res);
	
	//glcd_ctrl_port&=~_BV(glcd_rs);
	
	pause(5);// wait for power to stabilize
	
	glcd_ctrl_port|=_BV(glcd_res);
	//pause(1);

	glcd_write_byte_inreg(0b10110001);// power control register
	//pause(1);
	
	glcd_write_byte_inreg(0b10110010);// power control register
	//pause(1);
	
	glcd_write_byte_inreg(0b10000001);// power control register
	//pause(1);
	
	glcd_write_byte_inreg(0b11010011); // contrast level
	//pause(1);
	
	
	glcd_write_byte_inreg(0b10010000);//rev-0;nlin=0;swap=0;ref=0;
	//pause(1);
	
	glcd_write_byte_inreg(0b10100010);//increment control register; increment x+y=0011
	// increment x=0001; increment y = 0010
	//pause(1);
	
	return;
}

void glcd_clscr(void)
{
	// pos = 0
	glcd_write_byte_inreg(0b00000000); // set x adress
	glcd_write_byte_inreg(0b00100000); // set y adress
	glcd_write_byte_inreg(0b00110000); //set y y directionaddress in display ram
	
	glcd_write_byte_inreg(0b10100011);//increment control register; increment x and y auto
	
	for (unsigned int i=0; i<(0x0f+1)*(0x3f+1); i++)	glcd_write_byte_inram(0x00);
	
	glcd_write_byte_inreg(0b10100010);//increment control register;y auto increment
	
	// pos = 0
	glcd_write_byte_inreg(0b00000000); // set x adress
	glcd_write_byte_inreg(0b00100000); // set y adress
	glcd_write_byte_inreg(0b00110000); //set y y directionaddress in display ram
	
	return;
}

void glcd_x_pos (unsigned char x)
{
	glcd_write_byte_inreg((x/8)&0b00001111); // x 
	
	return;
}

void glcd_y_pos (unsigned char y)
{
	unsigned char tmp=0;
	tmp=y&0b00001111;
	glcd_write_byte_inreg(y+0b00100000);
	tmp=y&0b00110000;
	tmp=tmp>>4;
	glcd_write_byte_inreg(tmp+0b00110000);
	
	return;
}

void glcd_pos(unsigned char x,unsigned char y)
{
	glcd_write_byte_inreg((x/8)&0b00001111);

	glcd_write_byte_inreg((y&0b00001111)+0b00100000);

	glcd_write_byte_inreg(((y&0b00110000)>>4)+0b00110000);
	
	return;
}

void glcd_set_dot(unsigned char x, unsigned char y)
{
	unsigned char temp=0;
	
	glcd_pos(x,y);
	temp=glcd_read_byte_inram();
	
	glcd_pos(x,y);
	temp=glcd_read_byte_inram();
	
	glcd_pos(x,y);
	glcd_write_byte_inram(temp | (1 << (x % 8)));
	
	glcd_pos(x,y);
	
	return;

}

void glcd_clear_dot(unsigned char x, unsigned char y)
{
	unsigned char temp=0;
	
	glcd_pos(x,y);
	temp=glcd_read_byte_inram();
	
	glcd_pos(x,y);
	temp=glcd_read_byte_inram();
	
	glcd_pos(x,y);
	glcd_write_byte_inram(temp & ~(1 << (x % 8)));
	
	glcd_pos(x,y);
	return;

}

void glcdRectangle(unsigned char x, unsigned char y, unsigned char a, unsigned char b)
{
  unsigned char j;

  for (j = 0; j < a; j++) {
		glcd_set_dot(x, y + j);
		glcd_set_dot(x + b - 1, y + j);
	}
  for (j = 0; j < b; j++)	{
		glcd_set_dot(x + j, y);
		glcd_set_dot(x + j, y + a - 1);
	}
	return;
}

void glcd_put_char(unsigned char x, unsigned char y,unsigned int c)
{

	glcd_pos(x,y);
		
	for(unsigned char i=0; i<7; i++)
	{
		glcd_write_byte_inram((pgm_read_byte(&Font5x7[c*7  + i])));
	}
}


void put_val_3dig (unsigned char x,unsigned char y, unsigned char val)
{
	glcd_put_char(x,y,val/100+0x30);
	glcd_put_char(x+8,y,(val%100)/10+0x30);
	glcd_put_char(x+16,y,val%10+0x30);
	
	return;
}

void glcd_put_txt (unsigned char x,unsigned char y,unsigned char txt[])
{
	unsigned char i=0;
	while (txt[i]!=0)
	{
		glcd_put_char(x+i*8,y,txt[i]);   
		i++;
	}
}
