#include "user.h"

#include "font5x7.h"
#include <avr/pgmspace.h>

#define glcd_data_port	PORTA	// PORT for LCD data bus
#define glcd_data_ddr	DDRA	// DDR register of LCD_data_PORT
#define glcd_data_pin	PINA

#define glcd_ctrl_port	PORTF	// PORT for LCD data bus
#define glcd_ctrl_ddr	DDRF	// DDR register of LCD_data_PORT


#define glcd_res		PF5		
#define glcd_cs			PF6		
#define glcd_rs			PF7		
#define glcd_wr			PF4		
#define glcd_rd			PF3		


// lh155 control	

void glcd_port_init(void);

void glcd_reset (void);

void glcd_write_byte_inreg(unsigned char byte);
unsigned char glcd_read_byte_inreg(void);

void glcd_write_byte_inram(unsigned char byte);
unsigned char glcd_read_byte_inram(void);

void glcd_init (void);
void glcd_clscr(void);

void glcd_pos (unsigned char x, unsigned char y);
void glcd_x_pos (unsigned char x);
void glcd_y_pos (unsigned char y);

void glcd_set_dot(unsigned char x, unsigned char y);
void glcd_clear_dot(unsigned char x, unsigned char y);
void glcdRectangle(unsigned char x, unsigned char y, unsigned char a, unsigned char b);
void glcd_put_char(unsigned char x, unsigned char y,unsigned int c);

void put_val_3dig (unsigned char x,unsigned char y, unsigned char val);
void glcd_put_txt (unsigned char x,unsigned char y,unsigned char txt[]);

