#include "user.h"
#include "osc.h"

void avr_init(void);

unsigned char k_fr_div=4;
unsigned char k_att=2;

unsigned char k_o,k_f,k_sync,k_bl,k_h_l;

volatile unsigned char SRAM_i,i_razv,i_del;

unsigned char adc_array[0xff];

unsigned char adc_array_tmp[0xff];

unsigned char U_0,U_m_dc,U_m_ac=0;

unsigned char adc_res_tmp,adc_res;

unsigned char k_inp_sw,k_s,k_sync_sw=0;

ISR(INT1_vect) //  () 
{
	TIMSK|=_BV(TOIE0);
	return;
}

ISR(INT2_vect) //     
{
	
	TIMSK&=~_BV(TOIE0);
	
	EIMSK&=~_BV(INT2);
	EIMSK&=~_BV(INT1);
	
	PORTD|=_BV(r_w);
	
	gird();
	axis ();
	
	run_osc();
	
	//   
	for (SRAM_i=0;SRAM_i<0xff;SRAM_i++)
	{
		adc_array[SRAM_i]= 11+((PINC)/5);
		mcu_clk_imp();
	}	
	
	//  
	
	for(i_razv=125;i_razv>0;i_razv--) //  
	{
		
		solid_beam_clear(i_razv,adc_array_tmp[i_razv], adc_array_tmp[i_razv+1]);
		
	}
	for(i_razv=1;i_razv<126;i_razv++) //  
	{
		solid_beam_set(i_razv,adc_array[i_razv], adc_array[i_razv+1]);
		adc_array_tmp[i_razv] = adc_array[i_razv];
	}
	
	return;
}

ISR(TIMER0_OVF_vect)	//""     SRAM
{

		TIMSK&=~_BV(TOIE0);
		EIMSK&=~_BV(INT2);
		
		PORTD&=~_BV(r_w);
		
		
		run_osc();
		
		
		
		
		EIMSK|=_BV(INT2);
		EIMSK&=~_BV(INT1);
		
		
	return;	
}


int main (void) 
{	
	avr_init();
	glcd_init();
	glcd_clscr();
	
	gird();
	axis();
	
	glcd_put_char(24,1,123);
	glcd_put_char(72,1,124);

	
	// loading parameters
	//k_att=eeprom_read_byte(0x10);
	//k_fr_div=eeprom_read_byte(0x20);
	
	
	// 
	v_d_ind (k_att);
	att_sel(k_att);
	
	f_d_ind (k_fr_div);
	freq_div_sel(k_fr_div);

	inp_sw(k_inp_sw);
	sync_sw(k_sync_sw);
	h_l_sw(k_h_l);
	
	sinc_on_off_ind(k_s);
	
	//PORTG|=_BV(PG2);
	
	sei();
	//cli();lj
	
	for(;;)
	{
		
		//put_val_3dig (10,30,matrix_kbd());
		///*
		if (matrix_kbd()==204)
		{
			k_inp_sw++;
			if(k_inp_sw>1)	 k_inp_sw=0;
			inp_sw(k_inp_sw);
		}
		
		if (matrix_kbd()==216)
		{
			k_sync_sw++;
			if(k_sync_sw>1)	k_sync_sw=0;
			sync_sw(k_sync_sw);
		}
		
		if (matrix_kbd()==212)
		{
			k_h_l++;
			if(k_h_l>1)	k_h_l=0;
			h_l_sw(k_h_l);
		}
		
		if (matrix_kbd()==116)	//att up
		{
			k_att++;
			if(k_att>4) k_att=4;
			att_sel(k_att);
			v_d_ind (k_att);
			eeprom_write_byte(0x10,k_att);
			
		}
		if (matrix_kbd()==184)	//att down
		{
			k_att--;
			if(k_att>4) k_att=0;
			att_sel(k_att);
			v_d_ind (k_att);
			eeprom_write_byte(0x10,k_att);
			
		}
		
		if (matrix_kbd()==120)
		{
			k_fr_div++;
			if(k_fr_div>14)	k_fr_div=14;
			f_d_ind (k_fr_div);
			freq_div_sel(k_fr_div);
			eeprom_write_byte(0x20,k_fr_div);
		}
		
		if (matrix_kbd()==180)
		{
			k_fr_div--;
			if(k_fr_div>14)	k_fr_div=0;
			f_d_ind (k_fr_div);
			freq_div_sel(k_fr_div);
			eeprom_write_byte(0x20,k_fr_div);
		}
		
		if (matrix_kbd()==108)
		{
			k_s++;
			if(k_s>1)	k_s=0;
			sinc_on_off_ind(k_s);
			pause(700);
		}
		
		if (matrix_kbd()==172)
		{
			k_bl++;
			if(k_bl>1)	k_bl=0;
				switch (k_bl)
			{
				case 0: 
					OCR2=0;
					break;
				case 1:	
					OCR2=0x7f;
					break;
				default:
					break;
			}
		}
		
		sinc_on_off(k_s);
		//*/
		//pause(500);
	}

}

void avr_init (void)
{
//----------------------------------------------------

//   
	PORTA=0x00;
	DDRA=0xff;

//   
	PORTF=0b00000000;
	DDRF= 0b11111111;


	PORTB=0b11000000;
	DDRB= 0b10111111;

// 
	PORTE=0b11111111;
	DDRE= 0b00000000;

//
	PORTC=0x00;
	DDRC= 0x00;
	
	
//  

	PORTD=0b00000101;
	DDRD= 0b11111000;
	
	PORTG=0b00000;
	DDRG= 0b11111;


//-----------------------------------------------------
// 1    

	//TCCR1A=0b10000001;
	//TCCR1B=0b00001001;
	
	//  
	//OCR1A=10;
//----------------------------------------------------
// 
	//EIMSK=0;
//	EICRA=0b00000000;
	//EICRB=0;

//-----------------------------------------------------
// T2

	TCCR0=0b00000101; //    SRAM
//------------------------------------------------------
//-----------------------------------------------------
// T2
//  

	TCCR2=0b01101001; 
	//OCR2=0x1f; // 
//------------------------------------------------------
//  
	
	ADMUX &= 0x7F & 0xF1; ADMUX |= 0x40 | 0x02| 0x20;   

	ADCSRA &= 0xFB; ADCSRA |= 0x80 | 0x00 | 0x20 | 0x03; 
	
	ADCSRA |= 0x40;
}



