//SRC = $(TARGET).c glcd.c ks0108.c user.c
#include "user.h"
#include "osc.h"

void avr_init(void);

unsigned char k_fr_div=0;
unsigned char k_att=0;

unsigned char k_bl,k_hi_lo;

volatile unsigned char SRAM_i,i_razv;


unsigned char adc_array[0xff];

unsigned char adc_array_tmp[128];

//volatile unsigned char u_bat;

//unsigned char adc_res_tmp,adc_res;

unsigned char k_inp_sw,k_s,k_sync_sw=0;




ISR(INT1_vect) //  () 
{
	TIMSK|=_BV(TOIE0);
	
	return;
}

///*
ISR(INT0_vect) //     
{
	
	TIMSK&=~_BV(TOIE0);
	
	EIMSK&=~_BV(INT1);
	
	EIMSK&=~_BV(INT0);
	
	PORTB|=_BV(clk_sel);
	
	gird();
	box ();
	
	ce_pulse();
	
	//   
	for (SRAM_i=0;SRAM_i<0xff;SRAM_i++)
	{
		adc_array[SRAM_i]= ((((0xff-PINC)*100)/475)+1);
		mcu_clk_imp();
	}	
	
	
	//  
	for(i_razv=0;i_razv<126;i_razv++) //  
	{
		glcdClearDot(i_razv,adc_array_tmp[i_razv]);
		//solid_beam_clear(i_razv,adc_array_tmp[i_razv], adc_array_tmp[i_razv+1]);
		adc_array_tmp[i_razv] = adc_array[i_razv];
		//pause(10);
		
	}
	
	for(i_razv=0;i_razv<126;i_razv++) //  
	{
		glcdSetDot(i_razv,adc_array[i_razv]);
		//solid_beam_set(i_razv,adc_array[i_razv], adc_array[i_razv+1]);
		//pause(20);
		
	}

	//u_bat=res_ADC();
	
	//bat_ch (u_bat);
	
	PORTB&=~_BV(clk_sel);
	
	
	return;
}
///*

ISR(TIMER0_OVF_vect)	//""     SRAM
{

	TIMSK&=~_BV(TOIE0);
		
	PORTB&=~_BV(clk_sel);
		
	ce_pulse();
		
	pause(600); //   !!!!
		
	EIMSK|=_BV(INT0); 
	
	return;	
}
//*/


int main (void) 

{	
	//
	avr_init();
	glcdInit(); // GLCD
	glcdClearScreen(); // 		
	
	
	box();// 
	gird();// 
	
	
	//
	glcdSetAddress(25,LINE8);
	glcdPutStr("/");
	glcdSetAddress(70,LINE8);
	glcdPutStr("/");
	
	// 
	
	// attenuator
	k_att=eeprom_read_byte(0x01);
	att_sel(k_att);
	v_d_ind (k_att);
	
	//sampling frequency divider
	k_fr_div=eeprom_read_byte(0x02);
	f_d_ind (k_fr_div);
	freq_div_sel(k_fr_div);
	
	
	//input
	//k_inp_sw=eeprom_read_byte(0x03);
	inp_sw(k_inp_sw);
	
	// sync switch
	sync_sw(k_sync_sw);


	switch (k_s)
	{
		case 0: 
			glcdSetAddress(109,LINE8);
			glcdWrite_Simbol(0x05);
			break;
		case 1:		
			glcdSetAddress(109,LINE8);
			glcdWrite_Simbol(0x06);
			break;
		default:
			break;
	}
	
	switch (k_hi_lo)
	{
				case 0: //high
					PORTB&=~_BV(sync_h_l);
					glcdSetAddress(118,LINE8);
					glcdWrite_Simbol(0x0a);
					break;
				case 1:		//low
					PORTB|=_BV(sync_h_l);
					glcdSetAddress(118,LINE8);
					glcdWrite_Simbol(0x0b);
					break;
				default:
					PORTB&=~_BV(sync_h_l);
					glcdSetAddress(118,LINE8);
					glcdWrite_Simbol(0x0a);
					break;
	}
	// freq div
	
	//u_bat=res_ADC();
	//bat_ch (u_bat);
	
	sei();
	
	//cli();
	
	for(;;)
	{	
		
		//glcdDigIndication_LINE1(2,u_bat);
		//glcdDigIndication_LINE1(2,matrix_kbd());
	
		if(matrix_kbd()==172) //1
		{
			k_fr_div--;
			if (k_fr_div>15) k_fr_div=15;
			f_d_ind (k_fr_div);
			freq_div_sel(k_fr_div);
			eeprom_write_byte(0x02,k_fr_div);
		}
		if(matrix_kbd()==184)//2
		{
			k_fr_div++;
			if (k_fr_div>15) k_fr_div=0;
			f_d_ind (k_fr_div);
			freq_div_sel(k_fr_div);
			eeprom_write_byte(0x02,k_fr_div);
		}
		if(matrix_kbd()==116)//3
		{
			k_att--;
			if(k_att>5) k_att=5;
			att_sel(k_att);
			v_d_ind (k_att);
			eeprom_write_byte(0x01,k_att);
		}
		if(matrix_kbd()==180)//4
		{
			k_att++;
			if(k_att>5) k_att=0;
			att_sel(k_att);
			v_d_ind (k_att);
			eeprom_write_byte(0x01,k_att);
		}
		if(matrix_kbd()==204)//5
		{
			k_inp_sw++;
			if(k_inp_sw>1)	k_inp_sw=0;
			inp_sw(k_inp_sw);
		}
		if(matrix_kbd()==216)//6
		{
			k_sync_sw++;
			if(k_sync_sw>1)	k_sync_sw=0;
			sync_sw(k_sync_sw);
		}
		
		if(matrix_kbd()==120)//7
		{
			k_s++;
			if(k_s>1)	k_s=0;
			switch (k_s)
			{
				case 0: 
					glcdSetAddress(109,LINE8);
					glcdWrite_Simbol(0x05);
					break;
				case 1:		
					glcdSetAddress(109,LINE8);
					glcdWrite_Simbol(0x06);
					break;
				default:
					glcdSetAddress(110,LINE8);
					glcdWrite_Simbol(0x06);
					break;
			}
		}
		
		if(matrix_kbd()==108)//8
		{
			k_bl++;
			if (k_bl>1)k_bl=0;
			switch (k_bl)
			{
				case 0: 
					OCR2=0x7f;
					break;
				case 1:		
					OCR2=0x00;
					break;
				default:
					OCR2=0x00;
					break;
			}
		}
		
		if(matrix_kbd()==212)//8
		{
			k_hi_lo++;
			if (k_hi_lo>1)	k_hi_lo=0;
			
			switch (k_hi_lo)
			{
				case 0: //high
					PORTB&=~_BV(sync_h_l);
					glcdSetAddress(118,LINE8);
					glcdWrite_Simbol(0x0a);
					break;
				case 1:		//low
					PORTB|=_BV(sync_h_l);
					glcdSetAddress(118,LINE8);
					glcdWrite_Simbol(0x0b);
					break;
				default:
					PORTB&=~_BV(sync_h_l);
					glcdSetAddress(118,LINE8);
					glcdWrite_Simbol(0x0a);
					break;
			}
		}
		
		switch (k_s)
		{
			case 0: 
				TIMSK|=_BV(TOIE0);
				break;
			case 1:		
				EIMSK|=_BV(INT1);
				break;
			default:
				break;
		}
		


	}
	
}

void avr_init (void)
{
//----------------------------------------------------

//   KS107
	PORTA=0xff;
	DDRA=0xff;

//   
	PORTF=0b00000000;
	DDRF= 0b11111100;


	PORTB=0b00000000;
	DDRB= 0b11111101;

// 
	PORTE=0b11111111;
	DDRE= 0b00000000;

//
	PORTC=0x00;
	DDRC= 0x00;
	
//  

	PORTD=0b00000011;
	DDRD= 0b11111100;
	
	PORTG=0b00000;
	DDRG= 0b11111;



//-----------------------------------------------------
// 1    

	//TCCR1A=0b10000001;
	//TCCR1B=0b00001001;
	
	//  
	//OCR1A=10;
//----------------------------------------------------
// 
	EIMSK=0;
	//EICRA=0b00000000;
	EICRA=0b00000000;
	EICRB=0;

//-----------------------------------------------------
// T2

	//TCCR2=0b00000101; //    SRAM
	TCCR2=0b01101001; 
	//OCR2=0x1f; // 
//------------------------------------------------------
//-----------------------------------------------------
// T0
//  

	//TCCR0=0b01101001; 
	TCCR0=0b00000101;
//------------------------------------------------------
//  
	
	//ADMUX &= 0x7F & 0xF1; ADMUX |= 0x40 | 0x01| 0x20;   

	//ADCSRA &= 0xFB; ADCSRA |= 0x80 | 0x40 | 0x20 | 0x03; 
	
	//ADCSRA |= 0x40;
}
